Loading...
Searching...
No Matches
Halide::Internal::IRMatcher::NotOp< A > Struct Template Reference

`#include <IRMatch.h>`

## Classes

struct | pattern_tag

## Public Member Functions

template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2>
HALIDE_ALWAYS_INLINE bool | match (const NotOp< A2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
template<typename A1 = A>
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes

A | a

## Static Public Attributes

static constexpr uint32_t | binds = bindings<A>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Not
static constexpr IRNodeType | max_node_type = IRNodeType::Not
static constexpr bool | canonical = A::canonical
static constexpr bool | foldable = A::foldable

## Detailed Description

template<typename A>
struct Halide::Internal::IRMatcher::NotOp< A >

Definition at line 1612 of file IRMatch.h.

## Member Function Documentation

## match() [1/2]

template<typename A>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::NotOp< A >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1623 of file IRMatch.h.

References a, Halide::Internal::Not::a, Halide::Expr::get(), HALIDE_ALWAYS_INLINE, match(), and Halide::Internal::Not.

Referenced by match(), and match().

## match() [2/2]

template<typename A>
template<uint32_t bound, typename A2>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::NotOp< A >::match | ( | const NotOp< A2 > & | op,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1632 of file IRMatch.h.

References a, HALIDE_ALWAYS_INLINE, match(), and Halide::Internal::IRMatcher::unwrap().

## make()

template<typename A>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::NotOp< A >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint ) const

inline

Definition at line 1637 of file IRMatch.h.

References a, and Halide::Internal::Not::make().

## make_folded_const()

template<typename A>
template<typename A1 = A>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::NotOp< A >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1644 of file IRMatch.h.

References a, and HALIDE_ALWAYS_INLINE.

## Member Data Documentation

## a

template<typename A>

A Halide::Internal::IRMatcher::NotOp< A >::a

Definition at line 1614 of file IRMatch.h.

Referenced by make(), make_folded_const(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## binds

template<typename A>

uint32_t Halide::Internal::IRMatcher::NotOp< A >::binds = bindings<A>::mask

static constexpr

Definition at line 1616 of file IRMatch.h.

## min_node_type

template<typename A>

IRNodeType Halide::Internal::IRMatcher::NotOp< A >::min_node_type = IRNodeType::Not

static constexpr

Definition at line 1618 of file IRMatch.h.

## max_node_type

template<typename A>

IRNodeType Halide::Internal::IRMatcher::NotOp< A >::max_node_type = IRNodeType::Not

static constexpr

Definition at line 1619 of file IRMatch.h.

## canonical

template<typename A>

bool Halide::Internal::IRMatcher::NotOp< A >::canonical = A::canonical

static constexpr

Definition at line 1620 of file IRMatch.h.

## foldable

template<typename A>

bool Halide::Internal::IRMatcher::NotOp< A >::foldable = A::foldable

static constexpr

Definition at line 1641 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h